% Function that extract extrinsic parameters from Essential Matrix
% Toolbox created Carles Matabosch Gerones
% Universitat de Girona, Catalunya (Spain) March 2003

function [R1,t1,R2,t2]=extrinsics(E)      
oz=pi/2;
Rz=[cos(oz) -sin(oz) 0;sin(oz) cos(oz) 0;0 0 1];
[U1,D1,V1]=svd(E);
k=(D1(1,1)+D1(2,2))/2;
En=U1*[k 0 0;0 k 0;0 0 0]*V1';
[U,D,V]=svd(En);
R1=(U*Rz*V');
tx=E*inv(R1);
t1=[tx(3,2);tx(1,3);tx(2,1)];
T=tx;
E1=tx*R1;
oz=-pi/2;
Rz=[cos(oz) -sin(oz) 0;sin(oz) cos(oz) 0;0 0 1];
[U1,D1,V1]=svd(E);
k=(D1(1,1)+D1(2,2))/2;
En=U1*[k 0 0;0 k 0;0 0 0]*V1';
[U,D,V]=svd(En);
R2=(U*Rz*V');
tx2=E*inv(R2);
t2=[tx2(3,2);tx2(1,3);tx2(2,1)];
T2=tx2;
E2=tx2*R2;
