%Function that find the intersection between two lines
%where f1 and p1 are two points of the first line, and f2 and p2 two points
%of second one.
% Toolbox created Carles Matabosch Gerones
% Universitat de Girona, Catalunya (Spain) March 2003
function [P3,disterror]=intersection2(F1,P1,F2,P2)
n1=length(F1);
n2=length(P1);
n3=length(F2);
n4=length(P2);
if n1<n2
    F1=[F1;1];
end
if n3<n4
    F2=[F2;1];
end
u=F1(1)-P1(1);v=F1(2)-P1(2);w=F1(3)-P1(3);e=P1(1)-F2(1);f=P1(2)-F2(2);g=P1(3)-F2(3);
a=(u*g-e*w)/(f*w-v*g);
b=-(e+f*a)/g;
d=P1(1)+a*P1(2)+b*P1(3);
error=P2(1)+a*P2(2)+b*P2(3)+d;
if abs(error)<0.0001
    v1=F1-P1;
    v2=F2-P2;
    k2=(P1(2)-P2(2)+v1(2)/v1(1)*(P2(1)-P1(1)))/(v2(2)-v2(1)*v1(2)/v1(1));
    k=(P2(1)-P1(1)+k2*v2(1))/v1(1);
    P3a=P1+k*v1;
    P3b=P2+k2*v2;
    error=P3a-P3b;
    if norm(error)<0.01
        P3=P3a;
        disterror=0;
    else
        pq=F2-F1;
        u=P1-F1;
        v=P2-F2;
        alpha=(pq'*v-(pq'*u)*norm(v)^2/(u'*v))/((u'*v)-norm(u)^2*norm(v)^2/(u'*v));
        beta=(-pq'*u+alpha*norm(u)^2)/(u'*v);
        r=F1+alpha.*u;
        s=F2+beta.*v;
        P3=(r+s)./2;
        disterror=norm(r-s);
    end
else
    %We find the minimum distance between two lines
    pq=F2-F1;
    u=P1-F1;
    v=P2-F2;

    alpha=(pq'*v-(pq'*u)*norm(v)^2/(u'*v))/((u'*v)-norm(u)^2*norm(v)^2/(u'*v));
    beta=(-pq'*u+alpha*norm(u)^2)/(u'*v);
    r=F1+alpha.*u;
    s=F2+beta.*v;
    P3=(r+s)./2;
    disterror=norm(r-s);
end
