% Sample of self-calibration of a moving pin-hole camera
% Program under-construction. Some changes are needed in order to do the
% method robustness

% Toolbox created Carles Matabosch Gerones
% Universitat de Girona, Catalunya (Spain) March 2003

clear all;close; echo off
%Coordinates of 3D points in scene
warning off


r=125;
p1=[10;10;10];
p2=[p1(1)-r;p1(2);p1(3)];
p3=[p1(1);p1(2)-r;p1(3)];
p4=[p1(1)-r;p1(2)-r;p1(3)];
p5=[p1(1)-r;p1(2);p1(3)+r];
p6=[p1(1)-r;p1(2)-r;p1(3)+r];
p7=[p1(1);p1(2)-r;p1(3)+r];
p8=[p1(1);p1(2);p1(3)+r];
p9=[p1(1)-(r*0.5);p1(2)-(r*0.5);p1(3)+(r*0.5)];
p10=[p1(1)+(r*0.5);p1(2)-(r*0.5);p1(3)+(r*0.5)];
p11=[p1(1)+(r*0.5);p1(2)+(r*0.5);p1(3)+(r*0.5)];
p12=[p1(1)+(r*0.5);p1(2)+(r*0.5);p1(3)-(r*0.5)];
p13=[p1(1)+(r*0.5);p1(2)-(r*0.5);p1(3)-(r*0.5)];
p14=[p1(1)-(r*0.5);p1(2)+(r*0.5);p1(3)-(r*0.5)];
p15=[p1(1)-(r*0.5);p1(2)+(r*0.5);p1(3)+(r*0.5)];
p16=[p1(1)-(r*0.5);p1(2)-(r*0.5);p1(3)+(r*0.5)];
p17=[p1(1)-(r*0.5);p1(2)-(r*0.5);p1(3)-(r*0.5)];
p18=[p1(1)+(r*0.75);p1(2)-(r*0.75);p1(3)+(r*0.75)];
p19=[p1(1)+(r*0.75);p1(2)+(r*0.75);p1(3)+(r*0.75)];
p20=[p1(1)+(r*0.75);p1(2)+(r*0.75);p1(3)-(r*0.75)];
p21=[p1(1)+(r*0.75);p1(2)-(r*0.75);p1(3)-(r*0.75)];
p22=[p1(1)-(r*0.75);p1(2)+(r*0.75);p1(3)-(r*0.75)];
p23=[p1(1)-(r*0.75);p1(2)+(r*0.75);p1(3)+(r*0.75)];
p24=[p1(1)-(r*0.75);p1(2)-(r*0.75);p1(3)+(r*0.75)];
p25=[p1(1)-(r*0.75);p1(2)-(r*0.75);p1(3)-(r*0.75)];


%Rotation of 3D points respect world coordinates
C=[250;250;200];
ox=pi/5;
oy=pi/5;
oz=-pi/4;
Rx=[1 0 0;0 cos(ox) -sin(ox);0 sin(ox) cos(ox)];
Ry=[cos(oy) 0 sin(oy);0 1 0;-sin(oy) 0 cos(oy)];
Rz=[cos(oz) -sin(oz) 0;sin(oz) cos(oz) 0;0 0 1];
R=Rz*Ry*Rx;
T=[R C;0 0 0 1];
cor=T*[p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25;ones(1,25)];
p1=cor(1:3,1);
p2=cor(1:3,2);
p3=cor(1:3,3);
p4=cor(1:3,4); 
p5=cor(1:3,5); 
p6=cor(1:3,6);
p7=cor(1:3,7);
p8=cor(1:3,8);
p9=cor(1:3,9);
p10=cor(1:3,10);
p11=cor(1:3,11);
p12=cor(1:3,12);
p13=cor(1:3,13);
p14=cor(1:3,14);
p15=cor(1:3,15);
p16=cor(1:3,16);
p17=cor(1:3,17);
p18=cor(1:3,18);
p19=cor(1:3,19);
p20=cor(1:3,20);
p21=cor(1:3,21);
p22=cor(1:3,22);
p23=cor(1:3,23);
p24=cor(1:3,24);
p25=cor(1:3,25);
Points=[p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16 p17 p18 p19 p20 p21 p22 p23 p24 p25];

n=length(Points(1,:));
fprintf('Introduce gaussian noise: ');
soroll=input('');

% Parameters of Camera 1
%Posicio
C1=[0;200;200];  %Coordinates 3D of the focal length 
ox=pi/2;
oy=pi/2;
oz=pi/2;
Rx1=[1 0 0;0 cos(ox) -sin(ox);0 sin(ox) cos(ox)];  
Ry1=[cos(oy) 0 sin(oy);0 1 0;-sin(oy) 0 cos(oy)];
Rz1=[cos(oz) -sin(oz) 0;sin(oz) cos(oz) 0;0 0 1]; 
R1=Rz1*Ry1*Rx1; %Rotation matrix in order to express the orientation of camera
T1=[R1 C1;0 0 0 1]; %Ideal extrinsic parameters matrix
u01=256;
v01=200;
alfau1=512;
alfav1=400;
soroll1=soroll;
A1=[alfau1 0 u01 0;0 alfav1 v01 0;0 0 1 0]; % Ideal intrinsic parameters matrix
for i=1:n
    Pu1(:,i)=inv(T1)*[Points(:,i);1];   %Points 3D respect camera 1
    Pp1(:,i)=A1*Pu1(:,i);                     
    Pi1(1,i)=Pp1(1,i)/Pp1(3,i);        
    Pi1(2,i)=Pp1(2,i)/Pp1(3,i);         %Points 2D in pixels
    Pi1(1,i)=normrnd(Pi1(1,i),soroll1);  
    Pi1(2,i)=normrnd(Pi1(2,i),soroll1); %Points 2D in pixels with gaussian noise
    Pi1=round(Pi1);
end    

%Camera2
C2=[200;0;200];
ox2=0;
oy2=-pi/3;
oz2=-pi/2;
Rx2=[1 0 0;0 cos(ox2) -sin(ox2);0 sin(ox2) cos(ox2)];
Ry2=[cos(oy2) 0 sin(oy2);0 1 0;-sin(oy2) 0 cos(oy2)];
Rz2=[cos(oz2) -sin(oz2) 0;sin(oz2) cos(oz2) 0;0 0 1];
R2=Rz2*Ry2*Rx2;
T2=[R2 C2;0 0 0 1];
u02=u01;
v02=v01;
alfau2=alfau1;
alfav2=alfav1;
soroll2=soroll;
A2=[alfau2 0 u02 0;0 alfav2 v02 0;0 0 1 0];
for i=1:n
    Pu2(:,i)=inv(T2)*[Points(:,i);1];
    Pp2(:,i)=A2*Pu2(:,i);
    Pi2(1,i)=Pp2(1,i)/Pp2(3,i);
    Pi2(2,i)=Pp2(2,i)/Pp2(3,i);    
    Pi2(1,i)=normrnd(Pi2(1,i),soroll2);
    Pi2(2,i)=normrnd(Pi2(2,i),soroll2);
    Pi2=round(Pi2);
end

%Camera 3
C3=[0;400;200];
ox=pi/4;
oy=-pi/2;
oz=0;
Rx3=[1 0 0;0 cos(ox) -sin(ox);0 sin(ox) cos(ox)];
Ry3=[cos(oy) 0 sin(oy);0 1 0;-sin(oy) 0 cos(oy)];
Rz3=[cos(oz) -sin(oz) 0;sin(oz) cos(oz) 0;0 0 1];
R3=Rz3*Ry3*Rx3;
T3=[R3 C3;0 0 0 1];
u03=u01;
v03=v01;
alfau3=alfau1;
alfav3=alfav1;
soroll3=soroll;
A3=[alfau3 0 u03 0;0 alfav3 v03 0;0 0 1 0];
for i=1:n
    Pu3(:,i)=inv(T3)*[Points(:,i);1];
    Pp3(:,i)=A3*Pu3(:,i);
    Pi3(1,i)=Pp3(1,i)/Pp3(3,i);
    Pi3(2,i)=Pp3(2,i)/Pp3(3,i);   
    Pi3(1,i)=normrnd(Pi3(1,i),soroll3);
    Pi3(2,i)=normrnd(Pi3(2,i),soroll3); 
    Pi3=round(Pi3);
end    

%in the following equations the translation matrix between cameras are
%computing. Where Tij represents coordinates of points in i respect camera j

T12=inv(T2)*T1;
tx12=[0 -T12(3,4) T12(2,4);T12(3,4) 0 -T12(1,4);-T12(2,4) T12(1,4) 0];
R12=T12(1:3,1:3);
Er12=tx12*R12;

T31=inv(T1)*T3;
tx31=[0 -T31(3,4) T31(2,4);T31(3,4) 0 -T31(1,4);-T31(2,4) T31(1,4) 0];
R31=T31(1:3,1:3);  
Er31=tx31*R31;    

T23=inv(T3)*T2;
tx23=[0 -T23(3,4) T23(2,4);T23(3,4) 0 -T23(1,4);-T23(2,4) T23(1,4) 0];
R23=T23(1:3,1:3);
Er23=tx23*R23;

%Computing the ideal fundamental matrix from intrinsic and extrinsic
%parameters.
%These matrix are computing in order to compare with the real ones.

F12r=inv(A2(1:3,1:3))'*Er12*inv(A1(1:3,1:3));
F12r=F12r./F12r(3,3);
F31r=inv(A1(1:3,1:3))'*Er31*inv(A3(1:3,1:3));
F31r=F31r./F31r(3,3);
F23r=inv(A3(1:3,1:3))'*Er23*inv(A2(1:3,1:3));
F23r=F23r./F23r(3,3);

%computing fundamental matrix from point correspondece between two cameras

F12=funmateig([Pi2;Pi1]);
F31=funmateig([Pi1;Pi3]);
F23=funmateig([Pi3;Pi2]);

[U12,D12,V12]=svd(F12);
[U31,D31,V31]=svd(F31);
[U23,D23,V23]=svd(F23);

%Computing a vector to express all svd decomposition
jSF(1,:)=[D12(1,1) D12(2,2) U12(:,1)' U12(:,2)' U12(:,3)' V12(:,1)' V12(:,2)' V12(:,3)'];
jSF(2,:)=[D31(1,1) D31(2,2) U31(:,1)' U31(:,2)' U31(:,3)' V31(:,1)' V31(:,2)' V31(:,3)'];
jSF(3,:)=[D23(1,1) D23(2,2) U23(:,1)' U23(:,2)' U23(:,3)' V23(:,1)' V23(:,2)' V23(:,3)'];


%Computing the initial solution with principal point fixed
[Kini,Ai]=initialsolution(D12(1,1),D12(2,2),U12,V12,D31(1,1),D31(2,2),U31,V31,D23(1,1),D23(2,2),U23,V23,u01,v01);
fprintf('The initial solution of intrinsic parameters are the following ones: \n')
fprintf('au parameter = %f\n',Ai(1,1));
fprintf('av parameter = %f\n',Ai(2,2));
fprintf('u0 parameter = %f\n',Ai(1,3));
fprintf('v0 parameter = %f\n',Ai(2,3));
fprintf('Starting iteration process, please wait !!\n')
[A,error]=minimization(jSF,Kini);
fprintf('The final solution of intrinsic parameters are the following ones: \n')
fprintf('au parameter = %f\n',A(1,1));
fprintf('av parameter = %f\n',A(2,2));
fprintf('u0 parameter = %f\n',A(1,3));
fprintf('v0 parameter = %f\n',A(2,3));
fprintf('The error in Huang-Faugeras constraint is : %f \n',error)
if error>1;
    fprintf('Sorry, try again, because we don`t find a correct solution')
else
Et12=A'*F12*A;
Et31=A'*F31*A;
Et23=A'*F23*A;
[Rt12a,tt12a,Rt12b,tt12b]=extrinsics(Et12);
[Rt23a,tt23a,Rt23b,tt23b]=extrinsics(Et23);
[Rt31a,tt31a,Rt31b,tt31b]=extrinsics(Et31);

%reconstruction 3D

T12ra=[Rt12a tt12a;0 0 0 1];
T23ra=[Rt23a tt23a;0 0 0 1];
T31ra=[Rt31a tt31a;0 0 0 1];
T12rb=[Rt12b tt12b;0 0 0 1];
T23rb=[Rt23b tt23b;0 0 0 1];
T31rb=[Rt31b tt31b;0 0 0 1];
C1=[0;0;0;1];
C2a=inv(T12ra)*[0;0;0;1];
C3a=T31ra*[0;0;0;1];
C2b=inv(T12rb)*[0;0;0;1];
C3b=T31rb*[0;0;0;1];

%Obtenction the 3D points from points 2D in pixels 
for i=1:n
    Pc1r(:,i)=inv(A)*[Pi1(:,i);1];
    Pc2r(:,i)=inv(A)*[Pi2(:,i);1];
    Pc3r(:,i)=inv(A)*[Pi3(:,i);1];
    P1w(:,i)=[Pc1r(:,i);1];
    P2wa(:,i)=inv(T12ra)*[Pc2r(:,i);1];
    P3wa(:,i)=T31ra*[Pc3r(:,i);1];
    P2wb(:,i)=inv(T12rb)*[Pc2r(:,i);1];
    P3wb(:,i)=T31rb*[Pc3r(:,i);1];    
end
for i=1:n
    [Pwa(:,i), errora(i)]=intersection2(C1,P1w(:,i),C2a,P2wa(:,i));
    [Pwb(:,i), errorb(i)]=intersection2(C1,P1w(:,i),C2b,P2wb(:,i));
    [Pwa2(:,i), errora2(i)]=intersection2(C1,P1w(:,i),C3a,P3wa(:,i));
    [Pwb2(:,i), errorb2(i)]=intersection2(C1,P1w(:,i),C3b,P3wb(:,i));
end
Pwa=Pwa./(Pwa(3,1));
Pwb=Pwb./(Pwb(3,1));
Pwa2=Pwa2./(Pwa2(3,1));
Pwb2=Pwb2./(Pwb2(3,1));
figure
hold on
xlabel('x'); ylabel('y'); zlabel('z');
if (min(Pwa(3,:))>0 & min(Pwb(3,:))<0)
    T12r=T12ra;
    Pw=Pwa;
    cub(Pw,'r')
elseif (min(Pwa(3,:))<0 & min(Pwb(3,:))>0)
    T12r=T12rb;
    Pw=Pwb;
    cub(Pw,'r')
else
    fprintf('It`s no possible to determine the correct translation matrix T12\n')
end
if (min(Pwa2(3,:))>0 & min(Pwb2(3,:))<0)
    T31r=T31ra;
    Pw2=Pwa2;
    cub(Pw2,'r')
elseif (min(Pwa2(3,:))<0 & min(Pwb2(3,:))>0)
    T31r=T31rb;
    Pw2=Pwb2;
    cub(Pw2,'r')
else
    fprintf('It`s no possible to determine the correct translation matrix T31\n')
end
Pu1e=Pu1./Pu1(3,1) ; %Ideal 3D points respect camera 1 in the same scale as reconstructed ones
hold on
cub(Pu1e,'b')
end



